#!/usr/bin/python
import pygtk
pygtk.require('2.0')
import gtk

felder = "kelvin-feld", "celsius-feld", "fahrenheit-feld", "reaumur-feld", "rankine-feld"
wert = {}
widget = {}
handler = {}

class TemperaturApp:

    def delete_event(self, widget, event, data=None):
        return False

    def destroy(self, widget, data=None):
        gtk.main_quit()

    def geaendert(self, objekt, was):
        wert[was] = widget[was].get_value()
        if was == "celsius-feld":
            wert["kelvin-feld"] = wert["celsius-feld"] + 273.15
        elif was == "fahrenheit-feld":
            wert["kelvin-feld"] = (5.0/9.0)*(wert["fahrenheit-feld"]-32.0) + 273.15
        elif was == "reaumur-feld":
            wert["kelvin-feld"] = (5.0/4.0)*wert["reaumur-feld"] + 273.15
        elif was == "rankine-feld":
            wert["kelvin-feld"] = (5.0/9.0)*wert["rankine-feld"]
	
        if was != "celsius-feld":
            wert["celsius-feld"] = wert["kelvin-feld"] - 273.15
        if was != "fahrenheit-feld":
            wert["fahrenheit-feld"] = (9.0/5.0)*(wert["kelvin-feld"]-273.15) + 32.0
        if was != "reaumur-feld":
            wert["reaumur-feld"] = (4.0/5.0)*(wert["kelvin-feld"]-273.15)
        if was != "rankine-feld":
            wert["rankine-feld"] = (9.0/5.0)*wert["kelvin-feld"]

        for i in felder:
            if was != i:
                widget[i].handler_block(handler[i])
                widget[i].set_value(wert[i])
                widget[i].handler_unblock(handler[i])

    def __init__(self):
        builder = gtk.Builder()
        builder.add_from_file("temperatur.gtkbuilder")
        for i in (("fenster", "schliessknopf") + felder):
            widget[i] = builder.get_object(i)
        for i in felder:
            handler[i] = widget[i].connect("value_changed", self.geaendert, i)
        widget["schliessknopf"].connect_object("clicked", gtk.Window.destroy, widget["fenster"])
        widget["fenster"].connect("delete_event", self.delete_event)
        widget["fenster"].connect("destroy", self.destroy)
        widget["fenster"].show_all()
        widget["celsius-feld"].set_value(100)

    def main(self):
        gtk.main()
    
if __name__ == "__main__":
    app = TemperaturApp()
    app.main()
